// comments indicate manual edits to fix header-parser errors.

{$mode delphi}  //
{$modeswitch objectivec2}
unit Keynote;
interface
uses  //
  CTypes,
{$IFDEF NoCocoaAll}
  Foundation,
{$ELSE}
  CocoaAll,
{$ENDIF}
  ScriptingBridge,
  DefinedClassesKeynote;

(*
  KeynoteApplicationPtr = ^KeynoteApplication;
  KeynoteDocumentPtr = ^KeynoteDocument;
  KeynoteWindowPtr = ^KeynoteWindow;
  KeynoteThemePtr = ^KeynoteTheme;
  KeynoteRichTextPtr = ^KeynoteRichText;
  KeynoteCharacterPtr = ^KeynoteCharacter;
  KeynoteParagraphPtr = ^KeynoteParagraph;
  KeynoteWordPtr = ^KeynoteWord;
  KeynoteIWorkContainerPtr = ^KeynoteIWorkContainer;
  KeynoteSlidePtr = ^KeynoteSlide;
  KeynoteMasterSlidePtr = ^KeynoteMasterSlide;
  KeynoteIWorkItemPtr = ^KeynoteIWorkItem;
  KeynoteAudioClipPtr = ^KeynoteAudioClip;
  KeynoteShapePtr = ^KeynoteShape;
  KeynoteChartPtr = ^KeynoteChart;
  KeynoteImagePtr = ^KeynoteImage;
  KeynoteGroupPtr = ^KeynoteGroup;
  KeynoteLinePtr = ^KeynoteLine;
  KeynoteMoviePtr = ^KeynoteMovie;
  KeynoteTablePtr = ^KeynoteTable;
  KeynoteTextItemPtr = ^KeynoteTextItem;
  KeynoteRangePtr = ^KeynoteRange;
  KeynoteCellPtr = ^KeynoteCell;
  KeynoteRowPtr = ^KeynoteRow;
  KeynoteColumnPtr = ^KeynoteColumn;
  KeynoteGenericMethodsProtocolPtr = ^KeynoteGenericMethodsProtocol;
*)
const
  KeynoteSaveOptionsYes = 2036691744;
  KeynoteSaveOptionsNo = 1852776480;
  KeynoteSaveOptionsAsk = 1634954016;

type
  KeynoteSaveOptions = clong;
  KeynoteSaveOptionsPtr = ^KeynoteSaveOptions;

const
  KeynotePrintingErrorHandlingStandard = 1819767668;
  KeynotePrintingErrorHandlingDetailed = 1819763828;

type
  KeynotePrintingErrorHandling = clong;
  KeynotePrintingErrorHandlingPtr = ^KeynotePrintingErrorHandling;

const
  KeynoteSaveableFileFormatKeynote = 1265526374;

type
  KeynoteSaveableFileFormat = clong;
  KeynoteSaveableFileFormatPtr = ^KeynoteSaveableFileFormat;

const
  KeynoteExportFormatHTML = 1265136749;
  KeynoteExportFormatQuickTimeMovie = 1265463158;
  KeynoteExportFormatPDF = 1265656934;
  KeynoteExportFormatSlideImages = 1265200487;
  KeynoteExportFormatMicrosoftPowerPoint = 1265660020;
  KeynoteExportFormatKeynote09 = 1265329529;

type
  KeynoteExportFormat = clong;
  KeynoteExportFormatPtr = ^KeynoteExportFormat;

const
  KeynoteImageExportFormatsJPEG = 1265198698;
  KeynoteImageExportFormatsPNG = 1265198704;
  KeynoteImageExportFormatsTIFF = 1265198708;

type
  KeynoteImageExportFormats = clong;
  KeynoteImageExportFormatsPtr = ^KeynoteImageExportFormats;

const
  KeynoteMovieExportFormatsSmall = 1265460787;
  KeynoteMovieExportFormatsMedium = 1265460789;
  KeynoteMovieExportFormatsLarge = 1265460791;

type
  KeynoteMovieExportFormats = clong;
  KeynoteMovieExportFormatsPtr = ^KeynoteMovieExportFormats;

const
  KeynotePrintWhatIndividualSlides = 1265661801;
  KeynotePrintWhatSlideWithNotes = 1265661806;
  KeynotePrintWhatHandouts = 1265661800;

type
  KeynotePrintWhat = clong;
  KeynotePrintWhatPtr = ^KeynotePrintWhat;

const
  KeynotePDFImageQualityGood = 1265520688;
  KeynotePDFImageQualityBetter = 1265520689;
  KeynotePDFImageQualityBest = 1265520690;

type
  KeynotePDFImageQuality = clong;
  KeynotePDFImageQualityPtr = ^KeynotePDFImageQuality;

const
  KeynoteTransitionEffectsNoTransitionEffect = 1953393004;
  KeynoteTransitionEffectsMagicMove = 1953327734;
  KeynoteTransitionEffectsShimmer = 1953720429;
  KeynoteTransitionEffectsSparkle = 1953722475;
  KeynoteTransitionEffectsSwing = 1953724263;
  KeynoteTransitionEffectsObjectCube = 1953456994;
  KeynoteTransitionEffectsObjectFlip = 1953457776;
  KeynoteTransitionEffectsObjectPop = 1953460336;
  KeynoteTransitionEffectsObjectPush = 1953460328;
  KeynoteTransitionEffectsObjectRevolve = 1953460854;
  KeynoteTransitionEffectsObjectZoom = 1953462893;
  KeynoteTransitionEffectsPerspective = 1953526387;
  KeynoteTransitionEffectsClothesline = 1952672879;
  KeynoteTransitionEffectsConfetti = 1952671348;
  KeynoteTransitionEffectsDissolve = 1952737651;
  KeynoteTransitionEffectsDrop = 1952739952;
  KeynoteTransitionEffectsDroplet = 1952739436;
  KeynoteTransitionEffectsFadeThroughColor = 1952871523;
  KeynoteTransitionEffectsGrid = 1952936548;
  KeynoteTransitionEffectsIris = 1953067635;
  KeynoteTransitionEffectsMoveIn = 1953330793;
  KeynoteTransitionEffectsPush = 1953526632;
  KeynoteTransitionEffectsReveal = 1953658476;
  KeynoteTransitionEffectsSwitch = 1953724265;
  KeynoteTransitionEffectsWipe = 1953984613;
  KeynoteTransitionEffectsBlinds = 1952607332;
  KeynoteTransitionEffectsColorPlanes = 1952673900;
  KeynoteTransitionEffectsCube = 1952675170;
  KeynoteTransitionEffectsDoorway = 1952741241;
  KeynoteTransitionEffectsFall = 1952866668;
  KeynoteTransitionEffectsFlip = 1952868720;
  KeynoteTransitionEffectsFlop = 1952870256;
  KeynoteTransitionEffectsMosaic = 1953330019;
  KeynoteTransitionEffectsPageFlip = 1953523308;
  KeynoteTransitionEffectsPivot = 1953527412;
  KeynoteTransitionEffectsReflection = 1953654380;
  KeynoteTransitionEffectsRevolvingDoor = 1953654134;
  KeynoteTransitionEffectsScale = 1953719148;
  KeynoteTransitionEffectsSwap = 1953724272;
  KeynoteTransitionEffectsSwoosh = 1953724275;
  KeynoteTransitionEffectsTwirl = 1953789804;
  KeynoteTransitionEffectsTwist = 1953789801;

type
  KeynoteTransitionEffects = clong;
  KeynoteTransitionEffectsPtr = ^KeynoteTransitionEffects;

const
  KeynoteTAVTBottom = 1635148404;
  KeynoteTAVTCenter = 1633907826;
  KeynoteTAVTTop = 1635153008;

type
  KeynoteTAVT = clong;
  KeynoteTAVTPtr = ^KeynoteTAVT;

const
  KeynoteTAHTAutoAlign = 1633777012;
  KeynoteTAHTCenter = 1633907826;
  KeynoteTAHTJustify = 1634366324;
  KeynoteTAHTLeft = 1634494068;
  KeynoteTAHTRight = 1634888052;

type
  KeynoteTAHT = clong;
  KeynoteTAHTPtr = ^KeynoteTAHT;

const
  KeynoteNMSDAscending = 1634952046;
  KeynoteNMSDDescending = 1685283694;

type
  KeynoteNMSD = clong;
  KeynoteNMSDPtr = ^KeynoteNMSD;

const
  KeynoteNMCTAutomatic = 1717663092;
  KeynoteNMCTCheckbox = 1717789544;
  KeynoteNMCTCurrency = 1717794162;
  KeynoteNMCTDateAndTime = 1717859437;
  KeynoteNMCTFraction = 1717989985;
  KeynoteNMCTNumber = 1852662386;
  KeynoteNMCTPercent = 1718642034;
  KeynoteNMCTPopUpMenu = 1717792880;
  KeynoteNMCTScientific = 1718838121;
  KeynoteNMCTSlider = 1717793644;
  KeynoteNMCTStepper = 1717793652;
  KeynoteNMCTText = 1668577396;
  KeynoteNMCTDuration = 1717859698;
  KeynoteNMCTRating = 1718772084;
  KeynoteNMCTNumeralSystem = 1717792371;

type
  KeynoteNMCT = clong;
  KeynoteNMCTPtr = ^KeynoteNMCT;

const
  KeynoteItemFillOptionsNoFill = 1718185583;
  KeynoteItemFillOptionsColorFill = 1718182767;
  KeynoteItemFillOptionsGradientFill = 1718183794;
  KeynoteItemFillOptionsAdvancedGradientFill = 1718182247;
  KeynoteItemFillOptionsImageFill = 1718184301;
  KeynoteItemFillOptionsAdvancedImageFill = 1718182249;

type
  KeynoteItemFillOptions = clong;
  KeynoteItemFillOptionsPtr = ^KeynoteItemFillOptions;

const
  KeynotePlaybackRepetitionMethodNone = 1836479086;
  KeynotePlaybackRepetitionMethodLoop = 1836477552;
  KeynotePlaybackRepetitionMethodLoopBackAndForth = 1836474982;

type
  KeynotePlaybackRepetitionMethod = clong;
  KeynotePlaybackRepetitionMethodPtr = ^KeynotePlaybackRepetitionMethod;

const
  KeynoteLegacyChartTypePie_2d = 1885955378;
  KeynoteLegacyChartTypeVertical_bar_2d = 1986163250;
  KeynoteLegacyChartTypeStacked_vertical_bar_2d = 1937138226;
  KeynoteLegacyChartTypeHorizontal_bar_2d = 1751282226;
  KeynoteLegacyChartTypeStacked_horizontal_bar_2d = 1936220722;
  KeynoteLegacyChartTypePie_3d = 1885955379;
  KeynoteLegacyChartTypeVertical_bar_3d = 1986163251;
  KeynoteLegacyChartTypeStacked_vertical_bar_3d = 1937138227;
  KeynoteLegacyChartTypeHorizontal_bar_3d = 1751282227;
  KeynoteLegacyChartTypeStacked_horizontal_bar_3d = 1936220723;
  KeynoteLegacyChartTypeArea_2d = 1634886962;
  KeynoteLegacyChartTypeStacked_area_2d = 1935766066;
  KeynoteLegacyChartTypeLine_2d = 1818848818;
  KeynoteLegacyChartTypeLine_3d = 1818848819;
  KeynoteLegacyChartTypeArea_3d = 1634886963;
  KeynoteLegacyChartTypeStacked_area_3d = 1935766067;
  KeynoteLegacyChartTypeScatterplot_2d = 1935896626;

type
  KeynoteLegacyChartType = clong;
  KeynoteLegacyChartTypePtr = ^KeynoteLegacyChartType;

const
  KeynoteLegacyChartGroupingChartRow = 1262708594;
  KeynoteLegacyChartGroupingChartColumn = 1262708579;

type
  KeynoteLegacyChartGrouping = clong;
  KeynoteLegacyChartGroupingPtr = ^KeynoteLegacyChartGrouping;

type
  KeynoteGenericMethodsProtocol = objcprotocol external name 'KeynoteGenericMethods'
    procedure closeSaving_savingIn (saving: KeynoteSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure saveIn_as (in_: NSURL; as_: KeynoteSaveableFileFormat); message 'saveIn:as:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure delete; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure duplicateTo_withProperties_ (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure delete_; message 'delete';
  end;

type
  KeynoteApplication = objcclass external (SBApplication)
  public
    function documents: SBElementArray; message 'documents';
    function windows: SBElementArray; message 'windows';
    function name: NSString; message 'name';
    function frontmost: boolean; message 'frontmost';
    function version: NSString; message 'version';
    function open (x: id): id; message 'open:';
    procedure print_withProperties_printDialog (x: id; withProperties: NSDictionary; printDialog: boolean); message 'print:withProperties:printDialog:';
    procedure quitSaving (saving: KeynoteSaveOptions); message 'quitSaving:';
    function exists (x: id): boolean; message 'exists:';
    procedure showNext; message 'showNext';
    procedure showPrevious; message 'showPrevious';
  end;

type
  KeynoteDocument = objcclass external (SBObject, KeynoteGenericMethodsProtocol)
  public
    function name: NSString; message 'name';
    function modified: boolean; message 'modified';
    function file_: NSURL; message 'file';
    procedure exportTo_as_withProperties (to_: NSURL; as_: KeynoteExportFormat; withProperties: NSDictionary); message 'exportTo:as:withProperties:';  //
    procedure startFrom (from: KeynoteSlide); message 'startFrom:';
    procedure makeImageSlidesFiles_setTitles_master (files: NSArray; setTitles: boolean; master: KeynoteMasterSlide); message 'makeImageSlidesFiles:setTitles:master:';
    procedure stop; message 'stop';
    procedure showSlideSwitcher; message 'showSlideSwitcher';
    procedure hideSlideSwitcher; message 'hideSlideSwitcher';
    procedure moveSlideSwitcherForward; message 'moveSlideSwitcherForward';
    procedure moveSlideSwitcherBackward; message 'moveSlideSwitcherBackward';
    procedure cancelSlideSwitcher; message 'cancelSlideSwitcher';
    procedure acceptSlideSwitcher; message 'acceptSlideSwitcher';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: KeynoteSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure duplicateTo_withProperties_ (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: KeynoteSaveableFileFormat); message 'saveIn:as:';
  end;

type
  KeynoteWindow = objcclass external (SBObject, KeynoteGenericMethodsProtocol)
  public
    function name: NSString; message 'name';
    function id_: NSInteger; message 'id';
    procedure setIndex(newValue: NSInteger); message 'setIndex:';
    function index: NSInteger; message 'index';
    procedure setBounds(newValue: NSRect); message 'setBounds:';
    function bounds: NSRect; message 'bounds';
    function closeable: boolean; message 'closeable';
    function miniaturizable: boolean; message 'miniaturizable';
    procedure setMiniaturized(newValue: boolean); message 'setMiniaturized:';
    function miniaturized: boolean; message 'miniaturized';
    function resizable: boolean; message 'resizable';
    procedure setVisible(newValue: boolean); message 'setVisible:';
    function visible: boolean; message 'visible';
    function zoomable: boolean; message 'zoomable';
    procedure setZoomed(newValue: boolean); message 'setZoomed:';
    function zoomed: boolean; message 'zoomed';
    function document: KeynoteDocument; message 'document';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: KeynoteSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure duplicateTo_withProperties_ (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: KeynoteSaveableFileFormat); message 'saveIn:as:';
  end;


type
  KeynoteApplication_KeynoteSuite = objccategory external name 'KeynoteSuite' (KeynoteApplication)
    function themes: SBElementArray; message 'themes';
  end;

type
  KeynoteSuite = objccategory external (KeynoteDocument)
    function slides: SBElementArray; message 'slides';
    function masterSlides: SBElementArray; message 'masterSlides';
    function id_: NSString; message 'id';
    procedure setSlideNumbersShowing(newValue: boolean); message 'setSlideNumbersShowing:';
    function slideNumbersShowing: boolean; message 'slideNumbersShowing';
    procedure setDocumentTheme(newValue: KeynoteTheme); message 'setDocumentTheme:';
    function documentTheme: KeynoteTheme; message 'documentTheme';
    procedure setAutoLoop(newValue: boolean); message 'setAutoLoop:';
    function autoLoop: boolean; message 'autoLoop';
    procedure setAutoPlay(newValue: boolean); message 'setAutoPlay:';
    function autoPlay: boolean; message 'autoPlay';
    procedure setAutoRestart(newValue: boolean); message 'setAutoRestart:';
    function autoRestart: boolean; message 'autoRestart';
    procedure setMaximumIdleDuration(newValue: NSInteger); message 'setMaximumIdleDuration:';
    function maximumIdleDuration: NSInteger; message 'maximumIdleDuration';
    function currentSlide: KeynoteSlide; message 'currentSlide';
    procedure setHeight(newValue: NSInteger); message 'setHeight:';
    function height: NSInteger; message 'height';
    procedure setWidth(newValue: NSInteger); message 'setWidth:';
    function width: NSInteger; message 'width';
  end;


type
  KeynoteTheme = objcclass external (SBObject, KeynoteGenericMethodsProtocol)
  public
    function id_: NSString; message 'id';
    function name: NSString; message 'name';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: KeynoteSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure duplicateTo_withProperties_ (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: KeynoteSaveableFileFormat); message 'saveIn:as:';
  end;

type
  KeynoteRichText = objcclass external (SBObject, KeynoteGenericMethodsProtocol)
  public
    function characters: SBElementArray; message 'characters';
    function paragraphs: SBElementArray; message 'paragraphs';
    function words: SBElementArray; message 'words';
    procedure setColor(newValue: NSColor); message 'setColor:';
    function color: NSColor; message 'color';
    procedure setFont(newValue: NSString); message 'setFont:';
    function font: NSString; message 'font';
    procedure setSize(newValue: NSInteger); message 'setSize:';
    function size: NSInteger; message 'size';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: KeynoteSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure duplicateTo_withProperties_ (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: KeynoteSaveableFileFormat); message 'saveIn:as:';
  end;

type
  KeynoteCharacter = objcclass external (KeynoteRichText)
  end;

type
  KeynoteParagraph = objcclass external (KeynoteRichText)
  public
    function characters: SBElementArray; message 'characters';
    function words: SBElementArray; message 'words';
  end;

type
  KeynoteWord = objcclass external (KeynoteRichText)
  public
    function characters: SBElementArray; message 'characters';
  end;

type
  KeynoteIWorkContainer = objcclass external (SBObject, KeynoteGenericMethodsProtocol)
  public
    function audioClips: SBElementArray; message 'audioClips';
    function charts: SBElementArray; message 'charts';
    function images: SBElementArray; message 'images';
    function iWorkItems: SBElementArray; message 'iWorkItems';
    function groups: SBElementArray; message 'groups';
    function lines: SBElementArray; message 'lines';
    function movies: SBElementArray; message 'movies';
    function shapes: SBElementArray; message 'shapes';
    function tables: SBElementArray; message 'tables';
    function textItems: SBElementArray; message 'textItems';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: KeynoteSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure duplicateTo_withProperties_ (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: KeynoteSaveableFileFormat); message 'saveIn:as:';
  end;

type
  KeynoteSlide = objcclass external (KeynoteIWorkContainer)
  public
    procedure setBaseSlide(newValue: KeynoteMasterSlide); message 'setBaseSlide:';
    function baseSlide: KeynoteMasterSlide; message 'baseSlide';
    procedure setBodyShowing(newValue: boolean); message 'setBodyShowing:';
    function bodyShowing: boolean; message 'bodyShowing';
    procedure setSkipped(newValue: boolean); message 'setSkipped:';
    function skipped: boolean; message 'skipped';
    function slideNumber: NSInteger; message 'slideNumber';
    procedure setTitleShowing(newValue: boolean); message 'setTitleShowing:';
    function titleShowing: boolean; message 'titleShowing';
    function defaultBodyItem: KeynoteShape; message 'defaultBodyItem';
    function defaultTitleItem: KeynoteShape; message 'defaultTitleItem';
    procedure setPresenterNotes(newValue: KeynoteRichText); message 'setPresenterNotes:';
    function presenterNotes: KeynoteRichText; message 'presenterNotes';
    procedure setTransitionProperties(newValue: NSDictionary); message 'setTransitionProperties:';
    function transitionProperties: NSDictionary; message 'transitionProperties';
    procedure addChartRowNames_columnNames_data_type_groupBy (rowNames: NSArray; columnNames: NSArray; data: NSArray; type_: KeynoteLegacyChartType; groupBy: KeynoteLegacyChartGrouping); message 'addChartRowNames:columnNames:data:type:groupBy:';
  end;

type
  KeynoteMasterSlide = objcclass external (KeynoteSlide)
  public
    function name: NSString; message 'name';
  end;

type
  KeynoteIWorkItem = objcclass external (SBObject, KeynoteGenericMethodsProtocol)
  public
    procedure setHeight(newValue: NSInteger); message 'setHeight:';
    function height: NSInteger; message 'height';
    procedure setLocked(newValue: boolean); message 'setLocked:';
    function locked: boolean; message 'locked';
    function parent: KeynoteIWorkContainer; message 'parent';
    procedure setPosition(newValue: NSPoint); message 'setPosition:';
    function position: NSPoint; message 'position';
    procedure setWidth(newValue: NSInteger); message 'setWidth:';
    function width: NSInteger; message 'width';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: KeynoteSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure duplicateTo_withProperties_ (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: KeynoteSaveableFileFormat); message 'saveIn:as:';
  end;

type
  KeynoteAudioClip = objcclass external (KeynoteIWorkItem)
  public
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setClipVolume(newValue: NSInteger); message 'setClipVolume:';
    function clipVolume: NSInteger; message 'clipVolume';
    procedure setRepetitionMethod(newValue: KeynotePlaybackRepetitionMethod); message 'setRepetitionMethod:';
    function repetitionMethod: KeynotePlaybackRepetitionMethod; message 'repetitionMethod';
  end;

type
  KeynoteShape = objcclass external (KeynoteIWorkItem)
  public
    function backgroundFillType: KeynoteItemFillOptions; message 'backgroundFillType';
    procedure setObjectText(newValue: KeynoteRichText); message 'setObjectText:';
    function objectText: KeynoteRichText; message 'objectText';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
  end;

type
  KeynoteChart = objcclass external (KeynoteIWorkItem)
  end;

type
  KeynoteImage = objcclass external (KeynoteIWorkItem)
  public
    procedure setObjectDescription(newValue: NSString); message 'setObjectDescription:';
    function objectDescription: NSString; message 'objectDescription';
    function file_: NSURL; message 'file';
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  KeynoteGroup = objcclass external (KeynoteIWorkContainer)
  public
    procedure setHeight(newValue: NSInteger); message 'setHeight:';
    function height: NSInteger; message 'height';
    function parent: KeynoteIWorkContainer; message 'parent';
    procedure setPosition(newValue: NSPoint); message 'setPosition:';
    function position: NSPoint; message 'position';
    procedure setWidth(newValue: NSInteger); message 'setWidth:';
    function width: NSInteger; message 'width';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  KeynoteLine = objcclass external (KeynoteIWorkItem)
  public
    procedure setEndPoint(newValue: NSPoint); message 'setEndPoint:';
    function endPoint: NSPoint; message 'endPoint';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
    procedure setStartPoint(newValue: NSPoint); message 'setStartPoint:';
    function startPoint: NSPoint; message 'startPoint';
  end;

type
  KeynoteMovie = objcclass external (KeynoteIWorkItem)
  public
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setMovieVolume(newValue: NSInteger); message 'setMovieVolume:';
    function movieVolume: NSInteger; message 'movieVolume';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRepetitionMethod(newValue: KeynotePlaybackRepetitionMethod); message 'setRepetitionMethod:';
    function repetitionMethod: KeynotePlaybackRepetitionMethod; message 'repetitionMethod';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  KeynoteTable = objcclass external (KeynoteIWorkItem)
  public
    function cells: SBElementArray; message 'cells';
    function rows: SBElementArray; message 'rows';
    function columns: SBElementArray; message 'columns';
    function ranges: SBElementArray; message 'ranges';
    procedure setName(newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
    function cellRange: KeynoteRange; message 'cellRange';
    procedure setSelectionRange(newValue: KeynoteRange); message 'setSelectionRange:';
    function selectionRange: KeynoteRange; message 'selectionRange';
    procedure setRowCount(newValue: NSInteger); message 'setRowCount:';
    function rowCount: NSInteger; message 'rowCount';
    procedure setColumnCount(newValue: NSInteger); message 'setColumnCount:';
    function columnCount: NSInteger; message 'columnCount';
    procedure setHeaderRowCount(newValue: NSInteger); message 'setHeaderRowCount:';
    function headerRowCount: NSInteger; message 'headerRowCount';
    procedure setHeaderColumnCount(newValue: NSInteger); message 'setHeaderColumnCount:';
    function headerColumnCount: NSInteger; message 'headerColumnCount';
    procedure setFooterRowCount(newValue: NSInteger); message 'setFooterRowCount:';
    function footerRowCount: NSInteger; message 'footerRowCount';
    procedure sortBy_direction_inRows (by: KeynoteColumn; direction: KeynoteNMSD; inRows: KeynoteRange); message 'sortBy:direction:inRows:';
  end;

type
  KeynoteTextItem = objcclass external (KeynoteIWorkItem)
  public
    function backgroundFillType: KeynoteItemFillOptions; message 'backgroundFillType';
    procedure setObjectText(newValue: KeynoteRichText); message 'setObjectText:';
    function objectText: KeynoteRichText; message 'objectText';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  KeynoteRange = objcclass external (SBObject, KeynoteGenericMethodsProtocol)
  public
    function cells: SBElementArray; message 'cells';
    function columns: SBElementArray; message 'columns';
    function rows: SBElementArray; message 'rows';
    procedure setFontName(newValue: NSString); message 'setFontName:';
    function fontName: NSString; message 'fontName';
    procedure setFontSize(newValue: double); message 'setFontSize:';
    function fontSize: double; message 'fontSize';
    procedure setFormat(newValue: KeynoteNMCT); message 'setFormat:';
    function format: KeynoteNMCT; message 'format';
    procedure setAlignment(newValue: KeynoteTAHT); message 'setAlignment:';
    function alignment: KeynoteTAHT; message 'alignment';
    function name: NSString; message 'name';
    procedure setTextColor(newValue: NSColor); message 'setTextColor:';
    function textColor: NSColor; message 'textColor';
    procedure setTextWrap(newValue: boolean); message 'setTextWrap:';
    function textWrap: boolean; message 'textWrap';
    procedure setBackgroundColor(newValue: NSColor); message 'setBackgroundColor:';
    function backgroundColor: NSColor; message 'backgroundColor';
    procedure setVerticalAlignment(newValue: KeynoteTAVT); message 'setVerticalAlignment:';
    function verticalAlignment: KeynoteTAVT; message 'verticalAlignment';
    procedure clear; message 'clear';
    procedure merge; message 'merge';
    procedure unmerge; message 'unmerge';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: KeynoteSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure duplicateTo_withProperties_ (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: KeynoteSaveableFileFormat); message 'saveIn:as:';
  end;

type
  KeynoteCell = objcclass external (KeynoteRange)
  public
    function column: KeynoteColumn; message 'column';
    function row: KeynoteRow; message 'row';
    procedure setValue(newValue: id); message 'setValue:';
    function value: id; message 'value';
    function formattedValue: NSString; message 'formattedValue';
    function formula: NSString; message 'formula';
  end;

type
  KeynoteRow = objcclass external (KeynoteRange)
  public
    function address: NSInteger; message 'address';
    procedure setHeight(newValue: double); message 'setHeight:';
    function height: double; message 'height';
  end;

type
  KeynoteColumn = objcclass external (KeynoteRange)
  public
    function address: NSInteger; message 'address';
    procedure setWidth(newValue: double); message 'setWidth:';
    function width: double; message 'width';
  end;


type
  KeynoteApplication_CompatibilitySuite = objccategory external name 'CompatibilitySuite' (KeynoteApplication)
  end;

type
  KeynoteDocument_CompatibilitySuite = objccategory external name 'CompatibilitySuite' (KeynoteDocument)
  end;

type
  KeynoteSlide_CompatibilitySuite = objccategory external name 'CompatibilitySuite' (KeynoteSlide)
  end;

implementation
end.
