try
	tell application "Numbers"
		
		log name & " " & version --output app's name and version
		
		set numDoc to make new document with properties {name:"My Doc"} --create new document
		
		set name of sheet 0 of numDoc to "My Sheet" --change sheet's tab
		
		set numCell to cell 2 of row 2 of table 0 of sheet 0 of numDoc
		--get upper left-most non-header cell of doc's first sheet
		
		tell numCell --set cell's properties
			set value to 1.23
			set font size to 15
		end tell
		
		activate --move app to foreground
		
	end tell
	
on error errMsg number errorNumber
	return errMsg
end try
