// comments indicate manual edits to fix header-parser errors.

{$mode delphi}  //
{$modeswitch objectivec2}
unit Numbers;
interface
uses  //
  CTypes,
{$IFDEF NoCocoaAll}
  Foundation,
{$ELSE}
  CocoaAll,
{$ENDIF}
  ScriptingBridge,
  DefinedClassesNumbers;

(*
  NumbersApplicationPtr = ^NumbersApplication;
  NumbersDocumentPtr = ^NumbersDocument;
  NumbersWindowPtr = ^NumbersWindow;
  NumbersRichTextPtr = ^NumbersRichText;
  NumbersCharacterPtr = ^NumbersCharacter;
  NumbersParagraphPtr = ^NumbersParagraph;
  NumbersWordPtr = ^NumbersWord;
  NumbersIWorkContainerPtr = ^NumbersIWorkContainer;
  NumbersIWorkItemPtr = ^NumbersIWorkItem;
  NumbersAudioClipPtr = ^NumbersAudioClip;
  NumbersShapePtr = ^NumbersShape;
  NumbersChartPtr = ^NumbersChart;
  NumbersImagePtr = ^NumbersImage;
  NumbersGroupPtr = ^NumbersGroup;
  NumbersLinePtr = ^NumbersLine;
  NumbersMoviePtr = ^NumbersMovie;
  NumbersTablePtr = ^NumbersTable;
  NumbersTextItemPtr = ^NumbersTextItem;
  NumbersRangePtr = ^NumbersRange;
  NumbersCellPtr = ^NumbersCell;
  NumbersRowPtr = ^NumbersRow;
  NumbersColumnPtr = ^NumbersColumn;
  NumbersSheetPtr = ^NumbersSheet;
  NumbersTemplatePtr = ^NumbersTemplate;
  NumbersGenericMethodsProtocolPtr = ^NumbersGenericMethodsProtocol;
*)
const
  NumbersSaveOptionsYes = 2036691744;
  NumbersSaveOptionsNo = 1852776480;
  NumbersSaveOptionsAsk = 1634954016;

type
  NumbersSaveOptions = clong;
  NumbersSaveOptionsPtr = ^NumbersSaveOptions;

const
  NumbersPrintingErrorHandlingStandard = 1819767668;
  NumbersPrintingErrorHandlingDetailed = 1819763828;

type
  NumbersPrintingErrorHandling = clong;
  NumbersPrintingErrorHandlingPtr = ^NumbersPrintingErrorHandling;

const
  NumbersTAVTBottom = 1635148404;
  NumbersTAVTCenter = 1633907826;
  NumbersTAVTTop = 1635153008;

type
  NumbersTAVT = clong;
  NumbersTAVTPtr = ^NumbersTAVT;

const
  NumbersTAHTAutoAlign = 1633777012;
  NumbersTAHTCenter = 1633907826;
  NumbersTAHTJustify = 1634366324;
  NumbersTAHTLeft = 1634494068;
  NumbersTAHTRight = 1634888052;

type
  NumbersTAHT = clong;
  NumbersTAHTPtr = ^NumbersTAHT;

const
  NumbersNMSDAscending = 1634952046;
  NumbersNMSDDescending = 1685283694;

type
  NumbersNMSD = clong;
  NumbersNMSDPtr = ^NumbersNMSD;

const
  NumbersNMCTAutomatic = 1717663092;
  NumbersNMCTCheckbox = 1717789544;
  NumbersNMCTCurrency = 1717794162;
  NumbersNMCTDateAndTime = 1717859437;
  NumbersNMCTFraction = 1717989985;
  NumbersNMCTNumber = 1852662386;
  NumbersNMCTPercent = 1718642034;
  NumbersNMCTPopUpMenu = 1717792880;
  NumbersNMCTScientific = 1718838121;
  NumbersNMCTSlider = 1717793644;
  NumbersNMCTStepper = 1717793652;
  NumbersNMCTText = 1668577396;
  NumbersNMCTDuration = 1717859698;
  NumbersNMCTRating = 1718772084;
  NumbersNMCTNumeralSystem = 1717792371;

type
  NumbersNMCT = clong;
  NumbersNMCTPtr = ^NumbersNMCT;

const
  NumbersItemFillOptionsNoFill = 1718185583;
  NumbersItemFillOptionsColorFill = 1718182767;
  NumbersItemFillOptionsGradientFill = 1718183794;
  NumbersItemFillOptionsAdvancedGradientFill = 1718182247;
  NumbersItemFillOptionsImageFill = 1718184301;
  NumbersItemFillOptionsAdvancedImageFill = 1718182249;

type
  NumbersItemFillOptions = clong;
  NumbersItemFillOptionsPtr = ^NumbersItemFillOptions;

const
  NumbersPlaybackRepetitionMethodNone = 1836479086;
  NumbersPlaybackRepetitionMethodLoop = 1836477552;
  NumbersPlaybackRepetitionMethodLoopBackAndForth = 1836474982;

type
  NumbersPlaybackRepetitionMethod = clong;
  NumbersPlaybackRepetitionMethodPtr = ^NumbersPlaybackRepetitionMethod;

const
  NumbersSaveableFileFormatNumbers = 1316316774;

type
  NumbersSaveableFileFormat = clong;
  NumbersSaveableFileFormatPtr = ^NumbersSaveableFileFormat;

const
  NumbersExportFormatPDF = 1315988582;
  NumbersExportFormatMicrosoftExcel = 1315272812;
  NumbersExportFormatCSV = 1315140470;
  NumbersExportFormatNumbers09 = 1315859810;

type
  NumbersExportFormat = clong;
  NumbersExportFormatPtr = ^NumbersExportFormat;

const
  NumbersImageQualityGood = 1265520688;
  NumbersImageQualityBetter = 1265520689;
  NumbersImageQualityBest = 1265520690;

type
  NumbersImageQuality = clong;
  NumbersImageQualityPtr = ^NumbersImageQuality;

type
  NumbersGenericMethodsProtocol = objcprotocol external name 'NumbersGenericMethods'
    procedure closeSaving_savingIn (saving: NumbersSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure saveIn_as (in_: NSURL; as_: NumbersSaveableFileFormat); message 'saveIn:as:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure delete; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure delete_; message 'delete';
  end;

type
  NumbersApplication = objcclass external (SBApplication)
  public
    function documents: SBElementArray; message 'documents';
    function windows: SBElementArray; message 'windows';
    function name: NSString; message 'name';
    function frontmost: boolean; message 'frontmost';
    function version: NSString; message 'version';
    function open (x: id): id; message 'open:';
    procedure print_withProperties_printDialog (x: id; withProperties: NSDictionary; printDialog: boolean); message 'print:withProperties:printDialog:';
    procedure quitSaving (saving: NumbersSaveOptions); message 'quitSaving:';
    function exists (x: id): boolean; message 'exists:';
  end;

type
  NumbersDocument = objcclass external (SBObject, NumbersGenericMethodsProtocol)
  public
    function name: NSString; message 'name';
    function modified: boolean; message 'modified';
    function file_: NSURL; message 'file';
    procedure exportTo_as_withProperties (to_: NSURL; as_: NumbersExportFormat; withProperties: NSDictionary); message 'exportTo:as:withProperties:';  //

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: NumbersSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: NumbersSaveableFileFormat); message 'saveIn:as:';
  end;

type
  NumbersWindow = objcclass external (SBObject, NumbersGenericMethodsProtocol)
  public
    function name: NSString; message 'name';
    function id_: NSInteger; message 'id';
    procedure setIndex(newValue: NSInteger); message 'setIndex:';
    function index: NSInteger; message 'index';
    procedure setBounds(newValue: NSRect); message 'setBounds:';
    function bounds: NSRect; message 'bounds';
    function closeable: boolean; message 'closeable';
    function miniaturizable: boolean; message 'miniaturizable';
    procedure setMiniaturized(newValue: boolean); message 'setMiniaturized:';
    function miniaturized: boolean; message 'miniaturized';
    function resizable: boolean; message 'resizable';
    procedure setVisible(newValue: boolean); message 'setVisible:';
    function visible: boolean; message 'visible';
    function zoomable: boolean; message 'zoomable';
    procedure setZoomed(newValue: boolean); message 'setZoomed:';
    function zoomed: boolean; message 'zoomed';
    function document: NumbersDocument; message 'document';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: NumbersSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: NumbersSaveableFileFormat); message 'saveIn:as:';
  end;

type
  NumbersRichText = objcclass external (SBObject, NumbersGenericMethodsProtocol)
  public
    function characters: SBElementArray; message 'characters';
    function paragraphs: SBElementArray; message 'paragraphs';
    function words: SBElementArray; message 'words';
    procedure setColor(newValue: NSColor); message 'setColor:';
    function color: NSColor; message 'color';
    procedure setFont(newValue: NSString); message 'setFont:';
    function font: NSString; message 'font';
    procedure setSize(newValue: NSInteger); message 'setSize:';
    function size: NSInteger; message 'size';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: NumbersSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: NumbersSaveableFileFormat); message 'saveIn:as:';
  end;

type
  NumbersCharacter = objcclass external (NumbersRichText)
  end;

type
  NumbersParagraph = objcclass external (NumbersRichText)
  public
    function characters: SBElementArray; message 'characters';
    function words: SBElementArray; message 'words';
  end;

type
  NumbersWord = objcclass external (NumbersRichText)
  public
    function characters: SBElementArray; message 'characters';
  end;

type
  NumbersIWorkContainer = objcclass external (SBObject, NumbersGenericMethodsProtocol)
  public
    function audioClips: SBElementArray; message 'audioClips';
    function charts: SBElementArray; message 'charts';
    function images: SBElementArray; message 'images';
    function iWorkItems: SBElementArray; message 'iWorkItems';
    function groups: SBElementArray; message 'groups';
    function lines: SBElementArray; message 'lines';
    function movies: SBElementArray; message 'movies';
    function shapes: SBElementArray; message 'shapes';
    function tables: SBElementArray; message 'tables';
    function textItems: SBElementArray; message 'textItems';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: NumbersSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: NumbersSaveableFileFormat); message 'saveIn:as:';
  end;

type
  NumbersIWorkItem = objcclass external (SBObject, NumbersGenericMethodsProtocol)
  public
    procedure setHeight(newValue: NSInteger); message 'setHeight:';
    function height: NSInteger; message 'height';
    procedure setLocked(newValue: boolean); message 'setLocked:';
    function locked: boolean; message 'locked';
    function parent: NumbersIWorkContainer; message 'parent';
    procedure setPosition(newValue: NSPoint); message 'setPosition:';
    function position: NSPoint; message 'position';
    procedure setWidth(newValue: NSInteger); message 'setWidth:';
    function width: NSInteger; message 'width';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: NumbersSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: NumbersSaveableFileFormat); message 'saveIn:as:';
  end;

type
  NumbersAudioClip = objcclass external (NumbersIWorkItem)
  public
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setClipVolume(newValue: NSInteger); message 'setClipVolume:';
    function clipVolume: NSInteger; message 'clipVolume';
    procedure setRepetitionMethod(newValue: NumbersPlaybackRepetitionMethod); message 'setRepetitionMethod:';
    function repetitionMethod: NumbersPlaybackRepetitionMethod; message 'repetitionMethod';
  end;

type
  NumbersShape = objcclass external (NumbersIWorkItem)
  public
    function backgroundFillType: NumbersItemFillOptions; message 'backgroundFillType';
    procedure setObjectText(newValue: NumbersRichText); message 'setObjectText:';
    function objectText: NumbersRichText; message 'objectText';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
  end;

type
  NumbersChart = objcclass external (NumbersIWorkItem)
  end;

type
  NumbersImage = objcclass external (NumbersIWorkItem)
  public
    procedure setObjectDescription(newValue: NSString); message 'setObjectDescription:';
    function objectDescription: NSString; message 'objectDescription';
    function file_: NSURL; message 'file';
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  NumbersGroup = objcclass external (NumbersIWorkContainer)
  public
    procedure setHeight(newValue: NSInteger); message 'setHeight:';
    function height: NSInteger; message 'height';
    function parent: NumbersIWorkContainer; message 'parent';
    procedure setPosition(newValue: NSPoint); message 'setPosition:';
    function position: NSPoint; message 'position';
    procedure setWidth(newValue: NSInteger); message 'setWidth:';
    function width: NSInteger; message 'width';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  NumbersLine = objcclass external (NumbersIWorkItem)
  public
    procedure setEndPoint(newValue: NSPoint); message 'setEndPoint:';
    function endPoint: NSPoint; message 'endPoint';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
    procedure setStartPoint(newValue: NSPoint); message 'setStartPoint:';
    function startPoint: NSPoint; message 'startPoint';
  end;

type
  NumbersMovie = objcclass external (NumbersIWorkItem)
  public
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setMovieVolume(newValue: NSInteger); message 'setMovieVolume:';
    function movieVolume: NSInteger; message 'movieVolume';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRepetitionMethod(newValue: NumbersPlaybackRepetitionMethod); message 'setRepetitionMethod:';
    function repetitionMethod: NumbersPlaybackRepetitionMethod; message 'repetitionMethod';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  NumbersTable = objcclass external (NumbersIWorkItem)
  public
    function cells: SBElementArray; message 'cells';
    function rows: SBElementArray; message 'rows';
    function columns: SBElementArray; message 'columns';
    function ranges: SBElementArray; message 'ranges';
    procedure setName(newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
    function cellRange: NumbersRange; message 'cellRange';
    procedure setSelectionRange(newValue: NumbersRange); message 'setSelectionRange:';
    function selectionRange: NumbersRange; message 'selectionRange';
    procedure setRowCount(newValue: NSInteger); message 'setRowCount:';
    function rowCount: NSInteger; message 'rowCount';
    procedure setColumnCount(newValue: NSInteger); message 'setColumnCount:';
    function columnCount: NSInteger; message 'columnCount';
    procedure setHeaderRowCount(newValue: NSInteger); message 'setHeaderRowCount:';
    function headerRowCount: NSInteger; message 'headerRowCount';
    procedure setHeaderColumnCount(newValue: NSInteger); message 'setHeaderColumnCount:';
    function headerColumnCount: NSInteger; message 'headerColumnCount';
    procedure setFooterRowCount(newValue: NSInteger); message 'setFooterRowCount:';
    function footerRowCount: NSInteger; message 'footerRowCount';
    procedure sortBy_direction_inRows (by: NumbersColumn; direction: NumbersNMSD; inRows: NumbersRange); message 'sortBy:direction:inRows:';
    procedure transpose; message 'transpose';
  end;

type
  NumbersTextItem = objcclass external (NumbersIWorkItem)
  public
    function backgroundFillType: NumbersItemFillOptions; message 'backgroundFillType';
    procedure setObjectText(newValue: NumbersRichText); message 'setObjectText:';
    function objectText: NumbersRichText; message 'objectText';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  NumbersRange = objcclass external (SBObject, NumbersGenericMethodsProtocol)
  public
    function cells: SBElementArray; message 'cells';
    function columns: SBElementArray; message 'columns';
    function rows: SBElementArray; message 'rows';
    procedure setFontName(newValue: NSString); message 'setFontName:';
    function fontName: NSString; message 'fontName';
    procedure setFontSize(newValue: double); message 'setFontSize:';
    function fontSize: double; message 'fontSize';
    procedure setFormat(newValue: NumbersNMCT); message 'setFormat:';
    function format: NumbersNMCT; message 'format';
    procedure setAlignment(newValue: NumbersTAHT); message 'setAlignment:';
    function alignment: NumbersTAHT; message 'alignment';
    function name: NSString; message 'name';
    procedure setTextColor(newValue: NSColor); message 'setTextColor:';
    function textColor: NSColor; message 'textColor';
    procedure setTextWrap(newValue: boolean); message 'setTextWrap:';
    function textWrap: boolean; message 'textWrap';
    procedure setBackgroundColor(newValue: NSColor); message 'setBackgroundColor:';
    function backgroundColor: NSColor; message 'backgroundColor';
    procedure setVerticalAlignment(newValue: NumbersTAVT); message 'setVerticalAlignment:';
    function verticalAlignment: NumbersTAVT; message 'verticalAlignment';
    procedure clear; message 'clear';
    procedure merge; message 'merge';
    procedure unmerge; message 'unmerge';
    function addColumnAfter: SBObject; message 'addColumnAfter';
    function addColumnBefore: SBObject; message 'addColumnBefore';
    function addRowAbove: SBObject; message 'addRowAbove';
    function addRowBelow: SBObject; message 'addRowBelow';
    procedure remove; message 'remove';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: NumbersSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: NumbersSaveableFileFormat); message 'saveIn:as:';
  end;

type
  NumbersCell = objcclass external (NumbersRange)
  public
    function column: NumbersColumn; message 'column';
    function row: NumbersRow; message 'row';
    procedure setValue(newValue: id); message 'setValue:';
    function value: id; message 'value';
    function formattedValue: NSString; message 'formattedValue';
    function formula: NSString; message 'formula';
  end;

type
  NumbersRow = objcclass external (NumbersRange)
  public
    function address: NSInteger; message 'address';
    procedure setHeight(newValue: double); message 'setHeight:';
    function height: double; message 'height';
  end;

type
  NumbersColumn = objcclass external (NumbersRange)
  public
    function address: NSInteger; message 'address';
    procedure setWidth(newValue: double); message 'setWidth:';
    function width: double; message 'width';
  end;


type
  NumbersApplication_NumbersSuite = objccategory external name 'NumbersSuite' (NumbersApplication)
    function templates: SBElementArray; message 'templates';
  end;

type
  NumbersDocument_NumbersSuite = objccategory external name 'NumbersSuite' (NumbersDocument)
    function sheets: SBElementArray; message 'sheets';
    function id_: NSString; message 'id';
    function documentTemplate: NumbersTemplate; message 'documentTemplate';
    procedure setActiveSheet(newValue: NumbersSheet); message 'setActiveSheet:';
    function activeSheet: NumbersSheet; message 'activeSheet';
  end;


type
  NumbersSheet = objcclass external (NumbersIWorkContainer)
  public
    procedure setName(newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
  end;


type
  NumbersSuite = objccategory external (NumbersTable)
    procedure setFiltered(newValue: boolean); message 'setFiltered:';
    function filtered: boolean; message 'filtered';
    procedure setHeaderRowsFrozen(newValue: boolean); message 'setHeaderRowsFrozen:';
    function headerRowsFrozen: boolean; message 'headerRowsFrozen';
    procedure setHeaderColumnsFrozen(newValue: boolean); message 'setHeaderColumnsFrozen:';
    function headerColumnsFrozen: boolean; message 'headerColumnsFrozen';
  end;


type
  NumbersTemplate = objcclass external (SBObject, NumbersGenericMethodsProtocol)
  public
    function id_: NSString; message 'id';
    function name: NSString; message 'name';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: NumbersSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: NumbersSaveableFileFormat); message 'saveIn:as:';
  end;


type
  NumbersRange_CompatibilitySuite = objccategory external name 'CompatibilitySuite' (NumbersRange)
  end;

type
  NumbersRow_CompatibilitySuite = objccategory external name 'CompatibilitySuite' (NumbersRow)
  end;

type
  CompatibilitySuite = objccategory external (NumbersColumn)
  end;

implementation
end.
